﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Eggs : MonoBehaviour {

	Animator anim;

	private float birthTime, ripeVal;
	public float ripeMin = 4;
	public float ripeMax = 6 ;
	public float rotten = 10;
	private int State;
	public int eggLocation;

	public GameObject ripeMonsterPrefab, rottenMonsterPrefab, maxRottenMonsterPrefab, eggPrefab;

	// Use this for initialization
	void Start () {
		birthTime = Time.time;
		State = 0;
		anim = GetComponent<Animator> ();
		anim.SetInteger ("State", 0);//premie
		ripeVal = 0;
	}
	
	// Update is called once per frame
	void Update () {
		ripeVal = Time.time - birthTime;

		if (ripeVal >= ripeMin) {
			
			State = 1;
			anim.SetInteger ("State", 1);//ripe


			if (ripeVal >= ripeMax) {

				State = 2;
				anim.SetInteger ("State", 2);//rotten

				if (ripeVal >= rotten) {
					State = 3;

					Harvest ();
				}
			}
		}
	}

	public void Harvest () {
		if (State == 0) {				//premature
			return;
		} else if (State == 1) {		//ripe
			GameObject newMonster = Instantiate (ripeMonsterPrefab);
			newMonster.transform.position = new Vector2 (transform.position.x, transform.position.y + 1);
		} else if (State == 2) {		//rotting
			GameObject newMonster = Instantiate (rottenMonsterPrefab);
			newMonster.transform.position = new Vector2 (transform.position.x, transform.position.y + 1);
		} else {						//max rotten
			GameObject newMonster = Instantiate (maxRottenMonsterPrefab);
			newMonster.transform.position = new Vector2 (transform.position.x, transform.position.y + 1);
		}

		gameObject.GetComponentInParent<EggSpawningBehaviour> ().EggDestroyed (gameObject);

		Destroy (gameObject);
	}
}
