﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerController : MonoBehaviour {

	public float speed = 0.05f, invulnTime = 5f;
	private float lastInvulnTime;
	Animator anim;
	Animator heart;
	public int state, maxHealth = 3;
	private int currentHealth;
	public bool invulnerable = false;
	public GameObject[] Hearts;
	public GameObject deathEffect;
	public bool render = true;
	public SpriteRenderer sprite;

	void Start () {
		sprite = GetComponent<SpriteRenderer> ();
		currentHealth = maxHealth;
		anim = GetComponent<Animator> ();
		Hearts = new GameObject[]{
			GameObject.FindGameObjectWithTag ("Heart1"),
			GameObject.FindGameObjectWithTag ("Heart2"),
			GameObject.FindGameObjectWithTag ("Heart3")
		};
	}
	
	void Update () {

		Vector2 movement = new Vector2 (Input.GetAxisRaw("Horizontal"), Input.GetAxisRaw("Vertical"));
		movement = movement.normalized;

		if (movement.y < 0) {
			anim.SetBool("Idle",false);//idle
			anim.SetInteger ("State", 1);//down
			state = 1;
		} else if(movement.y > 0){
			anim.SetBool("Idle",false);//idle
			anim.SetInteger ("State", 4);//up
			state = 4;
		}
		if (movement.x < 0) {
			anim.SetBool("Idle",false);//idle
			anim.SetInteger ("State", 2);//left
			state = 2;
		} else if(movement.x > 0){
			anim.SetBool("Idle",false);//idle
			anim.SetInteger ("State", 3);//right
			state = 3;
		}
		if(movement.x == 0 && movement.y == 0){
			anim.SetBool("Idle",true);//idle
		}

		gameObject.transform.position = new Vector2 ((movement.x * speed) + transform.position.x, (movement.y * speed) + transform.position.y);

		if (invulnTime < Time.time - lastInvulnTime) {
			invulnerable = false;
			sprite.enabled = true;
		}
		if(invulnerable){
			sprite.enabled = !sprite.enabled;
		}
	}
	public void TakeDamage(int dmg = 1) {
		
		currentHealth -= 1;
		if (currentHealth >= 0 ) {
			Hearts [currentHealth].GetComponent<Animator> ().SetBool ("Dead", true);
		}
		if (currentHealth <= 0) {

			GameObject[] monsters = GameObject.FindGameObjectsWithTag ("Enemy");
			for (int i = 0; i < monsters.Length; i++) {
				monsters [i].GetComponent<MonsterController> ().enabled = false;
			}

			GameObject death = Instantiate (deathEffect);
			death.transform.position = gameObject.transform.position;

			Destroy (gameObject);
		}
		invulnerable = true;
		lastInvulnTime = Time.time;
	}

	public void GainHealth(){
		if (currentHealth < maxHealth && currentHealth >= 0) {
			Hearts[currentHealth].GetComponent<Animator> ().SetBool ("Dead",false);
			currentHealth++;
		}
	}
}
