﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class SoulControl : MonoBehaviour {

	public int maxSouls = 10;
	public int currentSouls;
	public GameObject beamPrefab;
	public GameObject player;

	public Text scoreText;
	public int score;

	Animator anim;

	// Use this for initialization
	void Start () {
		UpdateScore (0);
		currentSouls = 0;
		anim = GetComponent<Animator> ();
		anim.SetInteger ("State", 0);//no souls
		player = GameObject.FindGameObjectWithTag("Player");
	}
	
	// Update is called once per frame
	void Update () {
		anim.SetInteger ("State", currentSouls);
//		if (Input.GetButtonDown ("Fire1")) {
//			gainSoul ();
//		}
//		if (Input.GetButtonDown ("Fire2")) {
//			dumpSouls ();
//		}

	}

	//get soul from demon kill
	public void gainSoul(){
		GameObject.FindGameObjectWithTag ("Transmitter").GetComponent<Animator> ().ResetTrigger ("Shoot");
		if (currentSouls < maxSouls) {
			currentSouls++;
		}
	}

	//deposit souls
	public void dumpSouls(){

		Animator animator = GameObject.FindGameObjectWithTag ("Transmitter").GetComponent<Animator> ();

		if (currentSouls > 0 && currentSouls < 10) {
			animator.SetBool ("Big", false);
			animator.SetTrigger ("Shoot");
			Instantiate (beamPrefab);

		} else if (currentSouls == 10) {
			animator.SetBool ("Big", true);
			animator.SetTrigger ("Shoot");
			player.GetComponent<PlayerController> ().GainHealth ();
		}
		UpdateScore (currentSouls);
		currentSouls = 0;
	}

	public void UpdateScore(int add){
		score += add;
		scoreText.text = "Souls:\n" + score;
	}
		
}
