﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EggSpawningBehaviour : MonoBehaviour {

	public GameObject eggPrefab;

	public Vector2[] spawnLocations = new Vector2[14];
	private List<int> spawnLocationsOpen = new List<int>();

	public int maxEggs = 8, minEggs = 4;
	private int numEggs;

	private void Awake() {
		for (int i = 0; i < spawnLocations.Length; i++) {
			spawnLocationsOpen.Add (i);
		}
	}

	void Update() {
		if (numEggs < minEggs)
			SpawnEgg ();
		else if (numEggs < maxEggs) {
			if (Random.Range (1, 81) == 1) {
				SpawnEgg ();
			}
		}
	}

	public void SpawnEgg() {
		numEggs++;


		int x = Random.Range (0, spawnLocationsOpen.Count);

		GameObject newEgg = Instantiate (eggPrefab, gameObject.transform);

		newEgg.transform.position = spawnLocations[spawnLocationsOpen [x]];

		newEgg.GetComponent<Eggs> ().eggLocation = spawnLocationsOpen [x];

		spawnLocationsOpen.Remove (spawnLocationsOpen [x]);
	}

	public void EggDestroyed(GameObject egg) {
		numEggs--;

		spawnLocationsOpen.Add (egg.GetComponent<Eggs>().eggLocation);
	}

}
