﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerAttack : MonoBehaviour {

	private bool isAttacking = false;

	private float attackTimer = 0f, attackCoolDown = 0.2f;
	public float disjoint = 0.5f;

	public Collider2D attackHitBox;

	public Animator anim;

	void Awake () {
		attackHitBox.enabled = false;
	}
	
	void Update () {
		if (Input.GetButtonDown ("Jump") && !isAttacking) {
			isAttacking = true;
			attackTimer = attackCoolDown;
			anim.SetBool ("Attack",true);
			attackHitBox.enabled = true;

			if (anim.GetInteger("State") == 1) { //down
				attackHitBox.transform.position = new Vector2 (transform.position.x, transform.position.y - disjoint);
			} else if (anim.GetInteger("State") == 4) { //up
				attackHitBox.transform.position = new Vector2 (transform.position.x, transform.position.y + disjoint);
			} else if (anim.GetInteger("State") == 2) { //left
				attackHitBox.transform.position = new Vector2 (transform.position.x - disjoint, transform.position.y);
			} else if (anim.GetInteger("State") == 3) { //right
				attackHitBox.transform.position = new Vector2 (transform.position.x + disjoint, transform.position.y);
			}
		}

		if (isAttacking) {
			if (attackTimer > 0)
				attackTimer -= Time.deltaTime;
			else {
				isAttacking = false;
				attackHitBox.enabled = false;
				anim.SetBool ("Attack",false);
			}
		}
	}
		

}
